function Aug14003 = Import_for_timsfiles2(filename,howmanyiterations, startRow, endRow)
%IMPORTFILE Import numeric data from a text file as a matrix.
%   AUG14003 = IMPORTFILE(FILENAME) Reads data from text file FILENAME for
%   the default selection.
%
%   AUG14003 = IMPORTFILE(FILENAME, STARTROW, ENDROW) Reads data from rows
%   STARTROW through ENDROW of text file FILENAME.
%
% Example:
%   Aug14003 = importfile('Aug14_003.tims', 1, 2174);
%
%    See also TEXTSCAN.

% Auto-generated by MATLAB on 2017/08/16 14:22:43

%% Initialize variables.
delimiter = '\t';
if nargin<=3
    startRow = 1;
    endRow = inf;
end

%% Format string for each line of text:
%   column1: double (%f)
%	column2: double (%f)
%   column3: double (%f)
%	column4: double (%f)
%   column5: double (%f)
%	column6: double (%f)
% For more information, see the TEXTSCAN documentation.

for lauf=1:howmanyiterations
    index = lauf*2-1;
 prae(index) ='%';
 prae(index+1)='f';

end
formatSpec = [prae,'%[^\n\r]'];
%formatSpec = ['%f%f%f%f%f%f%[^\n\r]'];
%% Open the text file.
fileID = fopen(filename,'r');

%% Read columns of data according to format string.
% This call is based on the structure of the file used to generate this
% code. If an error occurs for a different file, try regenerating the code
% from the Import Tool.
dataArray = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'HeaderLines', startRow(1)-1, 'ReturnOnError', false);
for block=2:length(startRow)
    frewind(fileID);
    dataArrayBlock = textscan(fileID, formatSpec, endRow(block)-startRow(block)+1, 'Delimiter', delimiter, 'HeaderLines', startRow(block)-1, 'ReturnOnError', false);
    for col=1:length(dataArray)
        dataArray{col} = [dataArray{col};dataArrayBlock{col}];
    end
end

%% Close the text file.
fclose(fileID);

%% Post processing for unimportable data.
% No unimportable data rules were applied during the import, so no post
% processing code is included. To generate code which works for
% unimportable data, select unimportable cells in a file and regenerate the
% script.

%% Initialize column outputs.
%columnIndices = cumsum(~I);

%% Create output variable
Aug14003 = [dataArray{1:end-1}];
